package solver

import (
	_ "embed"
	"strconv"
	"strings"
)

//go:embed blocks.csv
var fileString string

func (solver *Solver) load_blocks() {
	for _, line := range strings.Split(strings.TrimSuffix(fileString, "\n"), "\n") {
		block, _ := strconv.Atoi(line)
		solver.blocks = append(solver.blocks, block)
	}
}
